#include <jni.h>
#include <pwd.h>

#ifndef _Included_org_jboss_community_SetUid
#define _Included_org_jboss_community_SetUid
#ifdef __cplusplus
extern "C" {
#endif

jobject getStatus(JNIEnv *env, int successCode, const char * message) {

   jstring message_str = (*env)->NewStringUTF(env, message);
   jboolean success = successCode;
   jclass cls = (*env)->FindClass(env, "Lorg/jboss/community/SetUid$Status;");
   jmethodID constructor = (*env)->GetMethodID(env, cls, "<init>", "(ZLjava/lang/String;)V");
   return (*env)->NewObject(env, cls, constructor, success, message_str);
}

JNIEXPORT jobject JNICALL Java_org_jboss_community_SetUid_setUid
  (JNIEnv *env, jobject obj, jstring username) {
  
      const char *user_str = (*env)->GetStringUTFChars(env, username, NULL);

      struct passwd *pwd = (struct passwd *)getpwnam(user_str);
      if(pwd == 0) {
         return (jobject)getStatus(env, 0, "Error getting uid/gid information for user.");
      }

      int uid = pwd->pw_uid;
      int gid = pwd->pw_gid;

      if(setgid(gid)) {
         return (jobject)getStatus(env, 0, "Error setting gid for user, current user may not have permission.");
      }

      if(setuid(uid)) {
         return (jobject)getStatus(env, 0, "Error setting uid for user, current user may not have permission.");
      }

      return (jobject)getStatus(env, 1, "Successfully set uid/gid.");
}

#ifdef __cplusplus
}
#endif
#endif

